# ----------------------------------------------------------------------
#
# Plot a VTS model using Paraview and directly render a nice view for
# plotting and saving figure.
#
# This script should be run in Paraview Python Shell window.
#
# Francois Lavoue, 10 March 2019
# Last updated FL, 19 July 2019
#
# ----------------------------------------------------------------------
#
# Notes:
#
# This script takes a VTS file generated by the seiscope_pytools.io.
# writes.gllparam2vts and fortrantable2vts functions as input, unlike
# its companion 21*.py that takes a VTK file generated by SEM46.
#
# These VTK and VTS files seem to adopt different z-axis conventions
# (up- vs. downward-pointing), which makes rendering the two with the
# exact same view not obvious (see view.Camera* settings below).
#
# Initial trace generated using paraview version 5.6.0. This script is
# therefore not very clean nor concise, but it does the job as it is.
# Commands also inspired from Exercises 3.8 to 3.12 in Paraview Tutorial.
#
# To ensure correct image size when batch processing, search for and
# uncomment the line `# renderView*.ViewSize = [*,*]` .
#
# To do: add slicing to visualize model interior.
#
# ----------------------------------------------------------------------


#### import the simple module from the paraview
from paraview.simple import *

## Init: Reset session and disable automatic camera reset on 'Show'
ResetSession()
paraview.simple._DisableFirstRenderCameraReset()


#-- user parameters

# working dir (must be an absolute path)
dir0 = '/Users/lavouef/git/PACIFIC/codes/design_and_run_sem46_simulations_in_synthetic_models.clean/results'

dir1 = 'results/output_run_simulation_in_simple_synthetic_model_v8a_2-horizontal-layers'

dir_in = ("%s/%s/vtk_files" % (dir0,dir1) )
dir_ou = ("%s/%s/figs"      % (dir0,dir1) )

param = 'vs'
units = 'm/s'

file_in = dir_in + ("/%s.vts" % param)
file_ou = dir_ou + ("/%s.png" % param)

# bounds for color scale
v_min = 2000.0
v_max = 4000.0

#v_min = -1e-14
#v_max =  1e-14

# plot sources and receivers?
plot_src = True
plot_rec = True

rad_src = 50.   # (m)
rad_rec = 25.

rgb_src = [1.0, 0.0, 0.0]
rgb_rec = [0.0, 1.0, 0.0]

# specify camera placement
view = lambda:0
view.CameraPosition = [-11650., 31395., -13835.]
view.CameraFocalPoint = [2500., 1000.0, 3357.]
view.CameraViewUp = [-0.1017, -0.5252, -0.8449]
view.CameraParallelScale = 11800.

# NB: this is case-dependent and you may not know the suitable values at first.
#     You may then leave the structure empty ("view = lambda:0") and change it
#     in a second time for another view obtained manually by typing the
#     following in the Paraview Python shell:
# view = GetActiveView()
# print(view.CameraPosition)
# print(view....)

#-- end user parameters


# create a new 'XML Structured Grid Reader' for VTS model
modelvts = XMLStructuredGridReader( FileName = [ file_in ] )
modelvts.PointArrayStatus = [ param ]

# create a new 'Legacy VTK Reader' for source and receivers
if plot_src :
   srcvtk = LegacyVTKReader( FileNames = dir_in + '/src.vtk' )
if plot_rec :
   recvtk = LegacyVTKReader( FileNames = dir_in + '/rec.vtk' )

# set active source
SetActiveSource(modelvts)

# get active view
renderView1 = GetActiveViewOrCreate('RenderView')
# uncomment the following to set a specific view size
# renderView1.ViewSize = [1048, 546]

# show data in view
modelvtsDisplay = Show(modelvts, renderView1)

# trace defaults for the display properties.
modelvtsDisplay.Representation = 'Surface'
modelvtsDisplay.ColorArrayName = [None, '']
modelvtsDisplay.OSPRayScaleArray = param
modelvtsDisplay.OSPRayScaleFunction = 'PiecewiseFunction'
modelvtsDisplay.SelectOrientationVectors = 'None'
modelvtsDisplay.ScaleFactor = 817.46025390625
modelvtsDisplay.SelectScaleArray = 'None'
modelvtsDisplay.GlyphType = 'Arrow'
modelvtsDisplay.GlyphTableIndexArray = 'None'
modelvtsDisplay.GaussianRadius = 40.873012695312504
modelvtsDisplay.SetScaleArray = ['POINTS', param]
modelvtsDisplay.ScaleTransferFunction = 'PiecewiseFunction'
modelvtsDisplay.OpacityArray = ['POINTS', param]
modelvtsDisplay.OpacityTransferFunction = 'PiecewiseFunction'
modelvtsDisplay.DataAxesGrid = 'GridAxesRepresentation'
modelvtsDisplay.SelectionCellLabelFontFile = ''
modelvtsDisplay.SelectionPointLabelFontFile = ''
modelvtsDisplay.PolarAxes = 'PolarAxesRepresentation'
modelvtsDisplay.ScalarOpacityUnitDistance = 41.500292380943044

# init the 'GridAxesRepresentation' selected for 'DataAxesGrid'
modelvtsDisplay.DataAxesGrid.XTitleFontFile = ''
modelvtsDisplay.DataAxesGrid.YTitleFontFile = ''
modelvtsDisplay.DataAxesGrid.ZTitleFontFile = ''
modelvtsDisplay.DataAxesGrid.XLabelFontFile = ''
modelvtsDisplay.DataAxesGrid.YLabelFontFile = ''
modelvtsDisplay.DataAxesGrid.ZLabelFontFile = ''

# init the 'PolarAxesRepresentation' selected for 'PolarAxes'
modelvtsDisplay.PolarAxes.PolarAxisTitleFontFile = ''
modelvtsDisplay.PolarAxes.PolarAxisLabelFontFile = ''
modelvtsDisplay.PolarAxes.LastRadialAxisTextFontFile = ''
modelvtsDisplay.PolarAxes.SecondaryRadialAxesTextFontFile = ''

# reset view to fit data
renderView1.ResetCamera()

# set scalar coloring
ColorBy(modelvtsDisplay, ('POINTS', param))

# rescale color and/or opacity maps used to include current data range
modelvtsDisplay.RescaleTransferFunctionToDataRange(True, False)

# show color bar/color legend
modelvtsDisplay.SetScalarBarVisibility(renderView1, True)

# get color transfer function/color map for param
modelLUT = GetColorTransferFunction(param)

# get opacity transfer function/opacity map for param
modelPWF = GetOpacityTransferFunction(param)
#modelvtsDisplay.ScalarOpacityFunction = modelPWF

# show color bar/color legend
modelvtsDisplay.SetScalarBarVisibility(renderView1, True)

# Rescale transfer function
modelLUT.RescaleTransferFunction(v_min,v_max)
modelPWF.RescaleTransferFunction(v_min,v_max)

## Change background color
renderView1.Background = [ 1.0, 1.0, 1.0 ]
renderView1.OrientationAxesLabelColor = [0., 0., 0.]
Render()

## Change axis and label color
# Make axis visible (1) or not (0)
modelvtsDisplay.DataAxesGrid.GridAxesVisibility = 1
# Properties modified on Display.DataAxesGrid
modelvtsDisplay.DataAxesGrid.XTitleColor = [0.0, 0.0, 0.0]
modelvtsDisplay.DataAxesGrid.YTitleColor = [0.0, 0.0, 0.0]
modelvtsDisplay.DataAxesGrid.ZTitleColor = [0.0, 0.0, 0.0]
modelvtsDisplay.DataAxesGrid.XLabelColor = [0.0, 0.0, 0.0]
modelvtsDisplay.DataAxesGrid.YLabelColor = [0.0, 0.0, 0.0]
modelvtsDisplay.DataAxesGrid.ZLabelColor = [0.0, 0.0, 0.0]

# Properties modified on modelvtsDisplay.DataAxesGrid
modelvtsDisplay.DataAxesGrid.XTitle = 'X (m)'
modelvtsDisplay.DataAxesGrid.YTitle = 'Y (m)'
modelvtsDisplay.DataAxesGrid.ZTitle = 'Z (m)'

# Properties modified on LUT
modelLUT.AutomaticRescaleRangeMode = 'Never'

# get color legend/bar for LUT in view renderView1
ColorBar = GetScalarBar(modelLUT, renderView1)

# Properties modified on ColorBar
ColorBar.Title = ("%s (%s)" % (param,units))
ColorBar.TitleColor = [0.0, 0.0, 0.0]
ColorBar.LabelColor = [0.0, 0.0, 0.0]
Render(); Show()

## toggle 3D widget visibility (only when running from the GUI [FL: not sure what that means...])
#Hide3DWidgets(proxy=clip3.ClipType)

#-- Show sources and receivers
if plot_src :
   SetActiveSource(srcvtk)
   srcvtkDisplay = Show(srcvtk, renderView1)
   srcvtkDisplay.SetRepresentationType('Point Gaussian')
   srcvtkDisplay.GaussianRadius = rad_src

   # change solid color of src
   srcvtkDisplay.DiffuseColor = rgb_src

if plot_rec :
   SetActiveSource(recvtk)
   recvtkDisplay = Show(recvtk, renderView1)
   recvtkDisplay.SetRepresentationType('Point Gaussian')
   recvtkDisplay.GaussianRadius = rad_rec

   # change solid color of rec
   recvtkDisplay.DiffuseColor = rgb_rec

# update the view to ensure updated data information
renderView1.Update()

# reset view to fit data
renderView1.ResetCamera()

#### saving camera placements for all active views

# change camera placement for renderView1 (if specified in user parameters)
try :
   renderView1.CameraPosition = view.CameraPosition
   renderView1.CameraFocalPoint = view.CameraFocalPoint
   renderView1.CameraViewUp = view.CameraViewUp
   renderView1.CameraParallelScale = view.CameraParallelScale
except :
   print()

#### uncomment the following to render all views
# RenderAllViews()
# alternatively, if you want to write images, you can use SaveScreenshot(...).

## Save figure
SaveScreenshot( file_ou )

